Attribute VB_Name = "ComDlgAndFuncs"
Option Explicit
Private Const API_TRUE = 1

' 
Private Type CHOOSECOLOR
        lStructSize As Long
        hwndOwner As Long
        hInstance As Long
        rgbResult As Long
        lpCustColors As Long
        flags As Long
        lCustData As Long
        lpfnHook As Long
        lpTemplateName As String
End Type
Private Const CC_RGBINIT = &H1
Private Const CC_FULLOPEN = &H2
Private Const CC_PREVENTFULLOPEN = &H4
Private Declare Function CHOOSECOLOR Lib "comdlg32.dll" Alias "ChooseColorA" (ByRef pChoosecolor As CHOOSECOLOR) As Long
Private Declare Function CommDlgExtendedError Lib "comdlg32.dll" () As Long

'  
Private Const LF_FACESIZE = 32
Private Type LOGFONT
        lfHeight As Long
        lfWidth As Long
        lfEscapement As Long
        lfOrientation As Long
        lfWeight As Long
        lfItalic As Byte
        lfUnderline As Byte
        lfStrikeOut As Byte
        lfCharSet As Byte
        lfOutPrecision As Byte
        lfClipPrecision As Byte
        lfQuality As Byte
        lfPitchAndFamily As Byte
        lfFaceName(LF_FACESIZE - 1) As Byte
End Type
Private Type CHOOSEFONT
        lStructSize As Long
        hwndOwner As Long          '  caller's window handle
        hDC As Long                '  printer DC/IC or NULL
        lpLogFont As Long          '  ptr. to a LOGFONT struct
        iPointSize As Long         '  10 * size in points of selected font
        flags As Long              '  enum. private type flags
        rgbColors As Long          '  returned text color
        lCustData As Long          '  data passed to hook fn.
        lpfnHook As Long           '  ptr. to hook function
        lpTemplateName As String   '  custom template name
        hInstance As Long          '  instance handle of.EXE that
                                   '  contains cust. dlg. template
        lpszStyle As String        '  return the style field here
                                   '  must be LF_FACESIZE or bigger
        nFonttype As Integer       '  same value reported to the EnumFonts
                                   '  call back with the extra FONTprivate type_
                                   '  bits added
        MISSING_ALIGNMENT As Integer
        nSizeMin As Long           '  minimum pt size allowed &
        nSizeMax As Long           '  max pt size allowed if
                                   '  CF_LIMITSIZE is used
End Type
Private Const CF_SCREENFONTS = &H1
Private Const CF_PRINTERFONTS = &H2
Private Const CF_INITTOLOGFONTSTRUCT = &H40&
Private Const CF_EFFECTS = &H100&
Private Const FW_BOLD = 700
Private Const FW_NORMAL = 400
Private Declare Function CHOOSEFONT Lib "comdlg32.dll" Alias "ChooseFontA" (pChoosefont As CHOOSEFONT) As Long

'  
Private Const CCHDEVICENAME = 32
Private Const CCHFORMNAME = 32
Private Type PRINTDLG
        lStructSize As Long
        hwndOwner As Long
        hDevMode As Long
        hDevNames As Long
        hDC As Long
        flags As Long
        nFromPage As Integer
        nToPage As Integer
        nMinPage As Integer
        nMaxPage As Integer
        nCopies As Integer
        hInstance As Long
        lCustData As Long
        lpfnPrintHook As Long
        lpfnSetupHook As Long
        lpPrintTemplateName As String
        lpSetupTemplateName As String
        hPrintTemplate As Long
        hSetupTemplate As Long
End Type
Private Type DEVMODE
        dmDeviceName As String * CCHDEVICENAME
        dmSpecVersion As Integer
        dmDriverVersion As Integer
        dmSize As Integer
        dmDriverExtra As Integer
        dmFields As Long
        dmOrientation As Integer
        dmPaperSize As Integer
        dmPaperLength As Integer
        dmPaperWidth As Integer
        dmScale As Integer
        dmCopies As Integer
        dmDefaultSource As Integer
        dmPrintQuality As Integer
        dmColor As Integer
        dmDuplex As Integer
        dmYResolution As Integer
        dmTTOption As Integer
        dmCollate As Integer
        dmFormName As String * CCHFORMNAME
        dmUnusedPadding As Integer
        dmBitsPerPel As Integer
        dmPelsWidth As Long
        dmPelsHeight As Long
        dmDisplayFlags As Long
        dmDisplayFrequency As Long
End Type
Private Type DEVNAMES
        wDriverOffset As Integer
        wDeviceOffset As Integer
        wOutputOffset As Integer
        wDefault As Integer
End Type
Private Const PD_RETURNDC = &H100
Private Const PD_PRINTTOFILE = &H20
Private Const PD_PAGENUMS = &H2
Private Const PD_SELECTION = &H1
Private Const DM_COLLATE As Long = &H8000
Private Declare Function PRINTDLG Lib "comdlg32.dll" Alias "PrintDlgA" (pPrintDlg As PRINTDLG) As Long

'  
Private Type POINTAPI
        X As Long
        Y As Long
End Type
Private Type RECT
        Left As Long
        Top As Long
        Right As Long
        Bottom As Long
End Type
Private Type PageSetupDlg
        lStructSize As Long
        hwndOwner As Long
        hDevMode As Long
        hDevNames As Long
        flags As Long
        ptPaperSize As POINTAPI
        rtMinMargin As RECT
        rtMargin As RECT
        hInstance As Long
        lCustData As Long
        lpfnPageSetupHook As Long
        lpfnPagePaintHook As Long
        lpPageSetupTemplateName As String
        hPageSetupTemplate As Long
End Type
Private Const PSD_MARGINS = &H2
Private Declare Function PageSetupDlg Lib "comdlg32.dll" Alias "PageSetupDlgA" (pPagesetupdlg As PageSetupDlg) As Long
Public pDevMode As DEVMODE
Public pDevNamese As DEVNAMES
Public pointToDevMode As Long
Public pointToDevNames As Long

'   
Private Type OPENFILENAME
        lStructSize As Long
        hwndOwner As Long
        hInstance As Long
        lpstrFilter As String
        lpstrCustomFilter As String
        nMaxCustFilter As Long
        nFilterIndex As Long
        lpstrFile As String
        nMaxFile As Long
        lpstrFileTitle As String
        nMaxFileTitle As Long
        lpstrInitialDir As String
        lpstrTitle As String
        flags As Long
        nFileOffset As Integer
        nFileExtension As Integer
        lpstrDefExt As String
        lCustData As Long
        lpfnHook As Long
        lpTemplateName As String
End Type
Private Const OFN_ALLOWMULTISELECT = &H200
Private Const OFN_EXPLORER = &H80000
Private Const OFN_FILEMUSTEXIST = &H1000
Private Const OFN_EXTENSIONDIFFERENT = &H400
Private Const OFN_LONGNAMES = &H200000
Private Const OFN_NOCHANGEDIR = &H8
Private Const OFN_NODEREFERENCELINKS = &H100000
Private Const OFN_OVERWRITEPROMPT = &H2
Private Const OFN_SHAREAWARE = &H4000
Private Declare Function GetOpenFileName Lib "comdlg32.dll" Alias "GetOpenFileNameA" (pOpenfilename As OPENFILENAME) As Long
Private Declare Function GetSaveFileName Lib "comdlg32.dll" Alias "GetSaveFileNameA" (pOpenfilename As OPENFILENAME) As Long

'  
Private Type BROWSEINFO
  hwndOwner As Long
  pidlRoot As Long
  pszDisplayName As String
  lpszTitle As String
  ulFlags As Long
  lpfn As Long
  lParam As Long
  iImage As Long
End Type
Private Const BIF_RETURNONLYFSDIRS = &H1
Private Const MAX_PATH = 260
Private Declare Function SHBrowseForFolder Lib "shell32.dll" Alias "SHBrowseForFolderA" (lpBrowseInfo As BROWSEINFO) As Long
Private Declare Function SHGetPathFromIDList Lib "shell32.dll" Alias "SHGetPathFromIDListA" (ByVal pidl As Long, ByVal pszPath As String) As Long
 
'    
Type OSVERSIONINFO   '  148 Bytes
        dwOSVersionInfoSize As Long
        dwMajorVersion As Long
        dwMinorVersion As Long
        dwBuildNumber As Long
        dwPlatformId As Long
        szCSDVersion As String * 128
End Type
Private Declare Function GetDiskFreeSpace Lib "kernel32" Alias "GetDiskFreeSpaceA" (ByVal lpRootPathName As String, lpSectorsPerCluster As Long, lpBytesPerSector As Long, lpNumberOfFreeClusters As Long, lpTotalNumberOfClusters As Long) As Long
Private Declare Function GetDiskFreeSpaceEx Lib "kernel32" Alias "GetDiskFreeSpaceExA" (ByVal lpRootPathName As String, lpFreeBytesAvailableToCaller As Currency, lpTotalNumberOfBytes As Currency, lpTotalNumberOfFreeBytes As Currency) As Long
Private Declare Function GetVersionEx Lib "kernel32" Alias "GetVersionExA" (lpVersionInformation As OSVERSIONINFO) As Long

'     
Private Type PROCESS_INFORMATION
        hProcess As Long
        hThread As Long
        dwProcessId As Long
        dwThreadId As Long
End Type
Private Type STARTUPINFO
        cb As Long
        lpReserved As Long
        lpDesktop As Long
        lpTitle As Long
        dwX As Long
        dwY As Long
        dwXSize As Long
        dwYSize As Long
        dwXCountChars As Long
        dwYCountChars As Long
        dwFillAttribute As Long
        dwFlags As Long
        wShowWindow As Integer
        cbReserved2 As Integer
        lpReserved2 As Long
        hStdInput As Long
        hStdOutput As Long
        hStdError As Long
End Type
Private Const INFINITE = &HFFFF
Private Const STARTF_USESHOWWINDOW = &H1
Private Const PROCESS_ALL_ACCESS = &H1F0FFF
Private Const PROCESS_CREATE_PROCESS = &H80
Private Const PROCESS_CREATE_THREAD = &H2
Private Const PROCESS_DUP_HANDLE = &H40
Private Const PROCESS_QUERY_INFORMATION = &H400
Private Const PROCESS_SET_INFORMATION = &H200
Private Const PROCESS_SET_QUOTA = &H100
Private Const PROCESS_TERMINATE = &H1
Private Const SEE_MASK_CONNECTNETDRV = &H80
Private Const SEE_MASK_DOENVSUBST = &H200
Private Const SEE_MASK_FLAG_DDEWAIT = &H100
Private Const SEE_MASK_FLAG_NO_UI = &H400
Private Const SEE_MASK_HOTKEY = &H20
Private Const SEE_MASK_ICON = &H10
Private Const SEE_MASK_NOCLOSEPROCESS = &H40
Private Const SEE_MASK_UNICODE = &H10000
Private Type SHELLEXECUTEINFO
        cbSize As Long
        fMask As Long
        hwnd As Long
        lpVerb As String
        lpFile As String
        lpParameters As String
        lpDirectory As String
        nShow As Long
        hInstApp As Long
        '  Optional fields
        lpIDList As Long
        lpClass As String
        hkeyClass As Long
        dwHotKey As Long
        hIcon As Long
        hProcess As Long
End Type
Private Const STILL_ACTIVE = &H103&
Private Declare Function CreateProcess Lib "kernel32" Alias "CreateProcessA" _
(ByVal lpApplicationName As Long, _
 ByVal lpCommandLine As String, _
 ByVal lpProcessAttributes As Long, _
 ByVal lpThreadAttributes As Long, _
 ByVal bInheritHandles As Long, _
 ByVal dwCreationFlags As Long, _
 ByVal lpEnvironment As Long, _
 ByVal lpCurrentDirectory As Long, _
 lpStartupInfo As STARTUPINFO, _
 lpProcessInformation As PROCESS_INFORMATION) As Long
Private Declare Sub Sleep Lib "kernel32" (ByVal dwMilliseconds As Long)
Private Declare Function OpenProcess Lib "kernel32" (ByVal dwDesiredAccess As Long, ByVal bInheritHandle As Long, ByVal dwProcessId As Long) As Long
Private Declare Function CloseHandle Lib "kernel32" (ByVal hObject As Long) As Long
Private Declare Function GetLastError Lib "kernel32" () As Long
Private Declare Function GetExitCodeProcess Lib "kernel32" (ByVal hProcess As Long, lpExitCode As Long) As Long
Private Declare Function ShellExecuteEx Lib "shell32.dll" Alias "ShellExecuteExA" (pShellExecuteInfo As SHELLEXECUTEINFO) As Long

'   
Private Declare Function GlobalLock Lib "kernel32" (ByVal hMem As Long) As Long
Private Declare Function GlobalUnlock Lib "kernel32" (ByVal hMem As Long) As Long
Private Declare Sub CopyMemory Lib "kernel32" Alias "RtlMoveMemory" (hpvDest As Any, hpvSource As Any, ByVal cbCopy As Long)
Private Declare Function GlobalFree Lib "kernel32" (ByVal hMem As Long) As Long

'     
Public Enum RunModeEnum
        RMEDefault = 0
        RMeopen = 1
        RMEPrint = 2
End Enum
Public Enum DiskSpaceModeEnum
        DSMEFreeSpace = 0
        DSMEFullSpace = 1
        DSMEAvailableSpace = 2
End Enum
Public Enum UnitModeEnum
        UMEByte = 0
        UMEKiloByte = 1
        UMEMegaByte = 2
End Enum
Public Enum RunResultEnum
        RRENotExecute = 0
        RRERunAndWaitSuccess = 1
        RRECantSynchronize = 2
End Enum
Public Enum OpenFileEnum
        OFEOpenForLoad = 1
        OFEOpenForSave = 2
End Enum

Public Function MyGetDiskFreeSpace(FreeSpace As Currency, DiskStr As String, Optional Unit As UnitModeEnum = 2, Optional SpaceMode As DiskSpaceModeEnum = 0) As Boolean
Dim SectorsPerCluster As Long
Dim BytesPerSector As Long
Dim NumberOfFreeClusters As Long
Dim TotalNumberOfClusters As Long
Dim n1 As Long
Dim St1 As String
Dim Vi As OSVERSIONINFO

Dim BytesAvailableToCaller As Currency
Dim TotalNumberOfBytes As Currency
Dim TotalNumberOfFreeBytes As Currency
Dim n2 As Currency

MyGetDiskFreeSpace = False
FreeSpace = 0

If Left(DiskStr, 1) = "\" Then
  If Right(DiskStr, 1) = ":" Then
    St1 = Mid(DiskStr, 1, Len(DiskStr) - 1) & "\"
  ElseIf Right(DiskStr, 1) <> "\" Then
    St1 = DiskStr & "\"
  Else
    St1 = DiskStr
  End If
Else
  St1 = Left(DiskStr, 1) & ":\"
End If

St1 = VB2LP(St1)

Vi.dwOSVersionInfoSize = 148
If GetVersionEx(Vi) <> API_TRUE Then Exit Function

If Vi.dwBuildNumber > 1000 Then
  If GetDiskFreeSpaceEx(St1, BytesAvailableToCaller, TotalNumberOfBytes, TotalNumberOfFreeBytes) = API_TRUE Then
    MyGetDiskFreeSpace = True
    Select Case SpaceMode
    Case 0 '  
      n2 = TotalNumberOfFreeBytes
    Case 1 '  
      n2 = TotalNumberOfBytes
    Case 2 '   
      n2 = BytesAvailableToCaller
    Case Else
      n2 = TotalNumberOfFreeBytes
    End Select
    Select Case Unit
    Case 0 ' 
      FreeSpace = n2 * 10000
    Case 1 ' 
      FreeSpace = n2 / 1024 * 10000
    Case 2 ' 
      FreeSpace = n2 / 1048576 * 10000
    Case Else
      FreeSpace = 0
    End Select
  End If
Else
  If GetDiskFreeSpace(ByVal St1, SectorsPerCluster, BytesPerSector, NumberOfFreeClusters, TotalNumberOfClusters) = API_TRUE Then
    MyGetDiskFreeSpace = True
    Select Case SpaceMode
    Case 0 '  
      n1 = NumberOfFreeClusters
    Case 1 '  
      n1 = TotalNumberOfClusters
    Case 2 '   
      n1 = TotalNumberOfClusters
    Case Else
      n1 = NumberOfFreeClusters
    End Select
    Select Case Unit
    Case 0 ' 
      FreeSpace = BytesPerSector * SectorsPerCluster * n1
    Case 1 ' 
      FreeSpace = BytesPerSector * SectorsPerCluster * n1 / 1024
    Case 2 ' 
      FreeSpace = BytesPerSector * SectorsPerCluster * n1 / 1048576
    Case Else
      FreeSpace = 0
    End Select
  End If
End If
End Function

Public Function MyBrowseFolder(DirStr As String, Optional hwndOwnerArg As Long = 0) As Boolean
Dim pBrowseInfo As BROWSEINFO
Dim List1 As Long
Dim PathStr As String
pBrowseInfo.hwndOwner = hwndOwnerArg
pBrowseInfo.ulFlags = BIF_RETURNONLYFSDIRS
pBrowseInfo.lpszTitle = VB2LP(" ")

List1 = SHBrowseForFolder(pBrowseInfo)

PathStr = LPBuff(MAX_PATH)
If SHGetPathFromIDList(ByVal List1, ByVal PathStr) = API_TRUE Then
  MyBrowseFolder = True
  DirStr = LP2VB(PathStr)
Else
  MyBrowseFolder = False
  DirStr = ""
End If
End Function

Public Function MyChooseColor(ColorArg As Long, Optional hwndOwnerArg As Long = 0) As Boolean
Dim pChoosecolor As CHOOSECOLOR
Static InitUserColor(15) As Long
Dim ResErr As Long
pChoosecolor.lStructSize = Len(pChoosecolor)
pChoosecolor.hwndOwner = hwndOwnerArg
If InitUserColor(0) = 0 Then
  InitUserColor(0) = ColorArg
End If
pChoosecolor.hInstance = App.hInstance
pChoosecolor.rgbResult = ColorArg
pChoosecolor.lpCustColors = VarPtr(InitUserColor(0))
pChoosecolor.flags = CC_RGBINIT ' Or CC_PREVENTFULLOPEN
If CHOOSECOLOR(pChoosecolor) = API_TRUE Then
  MyChooseColor = True
  ColorArg = pChoosecolor.rgbResult
Else
  MyChooseColor = False
End If
End Function

Public Function MyChooseFont(FontArg As StdFont, _
                Optional ColorArg As Long = 0, _
                Optional hwndOwnerArg As Long = 0, _
                Optional hDCArg As Long = 0) As Boolean
Const PointsPerTwip = 1440 / 72
Dim pChoosefont As CHOOSEFONT
Dim pLogFont As LOGFONT
Dim MyPrn As Printer
pChoosefont.flags = 0
pChoosefont.flags = pChoosefont.flags Or CF_EFFECTS
If FontArg.Name <> "" Then
  pLogFont.lfCharSet = FontArg.Charset
  pLogFont.lfWeight = FontArg.Weight
  pLogFont.lfItalic = FontArg.Italic
  pLogFont.lfUnderline = FontArg.Underline
  pLogFont.lfStrikeOut = FontArg.Strikethrough
  VB2BYTE FontArg.Name, pLogFont.lfFaceName
  If FontArg.Bold = True Then
    pLogFont.lfWeight = FW_BOLD
  Else
    pLogFont.lfWeight = FW_NORMAL
  End If
  pChoosefont.flags = pChoosefont.flags Or CF_INITTOLOGFONTSTRUCT
End If
pChoosefont.lStructSize = Len(pChoosefont)
pChoosefont.hwndOwner = hwndOwnerArg
If hDCArg = 0 Then
  pChoosefont.hDC = 0
  pChoosefont.flags = pChoosefont.flags Or CF_SCREENFONTS
  pLogFont.lfHeight = -(FontArg.Size * (PointsPerTwip / Screen.TwipsPerPixelY))
Else
  Set MyPrn = Printer
  pChoosefont.hDC = hDCArg
  pChoosefont.flags = pChoosefont.flags Or CF_PRINTERFONTS
  pLogFont.lfHeight = -(FontArg.Size * (PointsPerTwip / MyPrn.TwipsPerPixelY))
  Set MyPrn = Nothing
End If
pLogFont.lfHeight = -(FontArg.Size * (PointsPerTwip / Screen.TwipsPerPixelY))
pChoosefont.hInstance = App.hInstance
pChoosefont.iPointSize = FontArg.Size * 10
pChoosefont.lpLogFont = VarPtr(pLogFont)
pChoosefont.lpszStyle = LPBuff(255)
pChoosefont.rgbColors = ColorArg
If CHOOSEFONT(pChoosefont) = API_TRUE Then
  MyChooseFont = True
  If Not IsMissing(ColorArg) Then
    ColorArg = pChoosefont.rgbColors
  End If
  If pLogFont.lfWeight = FW_BOLD Then
    FontArg.Bold = True
  Else
    FontArg.Bold = False
  End If
  FontArg.Charset = pLogFont.lfCharSet
  FontArg.Italic = pLogFont.lfItalic
  FontArg.Name = BYTE2VB(pLogFont.lfFaceName)
  FontArg.Size = pChoosefont.iPointSize / 10
  FontArg.Strikethrough = pLogFont.lfStrikeOut
  FontArg.Underline = pLogFont.lfUnderline
Else
  MyChooseFont = False
'  ResErr = CommDlgExtendedError
'  Debug.Print ResErr
End If
End Function

Public Function MyGetFileName(OpenMode As OpenFileEnum, _
                              DirStr As String, _
                              FileNameStr() As String, _
                              FilterMass() As String, _
                              Optional FileExt As String = "", _
                              Optional hwndOwnerArg As Long = 0 _
                              ) As Boolean
Dim pOpenfilename As OPENFILENAME
Dim n As Integer
Dim i As Integer
Dim X As Long
Dim St1 As String
Dim St2 As String
Dim St3 As String
pOpenfilename.lStructSize = Len(pOpenfilename)
pOpenfilename.hwndOwner = hwndOwnerArg
If OpenMode = OFEOpenForLoad Then
  pOpenfilename.lpstrTitle = " "
Else
  pOpenfilename.lpstrTitle = " "
End If
If UBound(FilterMass, 1) = 1 Then
  n = UBound(FilterMass, 2)
  If n >= 0 Then
    For i = 0 To n
      If Len(FilterMass(1, i)) > 1 Then
        If Len(FilterMass(0, i)) > 1 Then
          St1 = St1 & (FilterMass(0, i) + vbNullChar)
        Else
          St1 = St1 & (" " + vbNullChar)
        End If
        St1 = St1 & (FilterMass(1, i) + vbNullChar)
      End If
    Next
    St1 = St1 & vbNullChar & vbNullChar
  Else
    St1 = " " & vbNullChar & "*.*" & vbNullChar & vbNullChar
  End If
End If
If FileExt <> "" Then
pOpenfilename.lpstrDefExt = FileExt
End If
pOpenfilename.lpstrInitialDir = DirStr
pOpenfilename.lpstrFilter = St1
pOpenfilename.lpstrFile = LPBuff(512)
pOpenfilename.nMaxFile = 511
pOpenfilename.lpstrFileTitle = LPBuff(512)
pOpenfilename.nMaxFileTitle = 511
pOpenfilename.flags = OFN_SHAREAWARE Or OFN_LONGNAMES Or OFN_NODEREFERENCELINKS Or OFN_EXPLORER
If OpenMode = OFEOpenForLoad Then
  pOpenfilename.flags = pOpenfilename.flags Or OFN_ALLOWMULTISELECT
  X = GetOpenFileName(pOpenfilename)
Else
  pOpenfilename.flags = pOpenfilename.flags Or OFN_OVERWRITEPROMPT
  X = GetSaveFileName(pOpenfilename)
End If
If X = API_TRUE Then
  MyGetFileName = True
  St1 = LP2VB2(pOpenfilename.lpstrFile)
  DirStr = Left(St1, pOpenfilename.nFileOffset - 1)
  n = -1
  St2 = St1
  Do
    St3 = MyGetLpStr(St2)
    n = n + 1
  Loop Until St2 = ""
  If n >= 1 Then
    ReDim FileNameStr(n - 1)
    St2 = St1
    St3 = MyGetLpStr(St2)
    For i = 1 To n
      FileNameStr(i - 1) = MyGetLpStr(St2)
    Next
  Else
    ReDim FileNameStr(0)
    FileNameStr(0) = Right$(St1, Len(St1) - pOpenfilename.nFileOffset)
  End If
Else
  MyGetFileName = False
  DirStr = ""
  ReDim FileNameStr(0)
  FileNameStr(0) = ""
'  ResErr = CommDlgExtendedError
'  Debug.Print ResErr
End If
End Function

Public Function MyPageSetupDlg(PrnArg As Printer, _
                               LeftMargin As Long, _
                               RightMargin As Long, _
                               TopMargin As Long, _
                               BottomMargin As Long, _
                               Optional hwndOwnerArg As Long = 0 _
                                      ) As Boolean
Static pPagesetupdlg As PageSetupDlg
pPagesetupdlg.lStructSize = Len(pPagesetupdlg)
pPagesetupdlg.hwndOwner = hwndOwnerArg
If pointToDevMode <> 0 Then
  pPagesetupdlg.hDevMode = pointToDevMode
  pPagesetupdlg.hDevNames = pointToDevNames
End If
pPagesetupdlg.hInstance = App.hInstance
pPagesetupdlg.flags = PSD_MARGINS
pPagesetupdlg.rtMargin.Left = LeftMargin
pPagesetupdlg.rtMargin.Right = RightMargin
pPagesetupdlg.rtMargin.Bottom = BottomMargin
pPagesetupdlg.rtMargin.Top = TopMargin


If PageSetupDlg(pPagesetupdlg) = API_TRUE Then
  MyPageSetupDlg = True
  MyCopyStructure pDevMode, pPagesetupdlg.hDevMode
  PrnArg.Copies = pDevMode.dmCopies
  PrnArg.Orientation = pDevMode.dmOrientation
  PrnArg.PaperSize = pDevMode.dmPaperSize
  PrnArg.PrintQuality = pDevMode.dmPrintQuality
  pointToDevMode = pPagesetupdlg.hDevMode
  pointToDevNames = pPagesetupdlg.hDevNames
  LeftMargin = pPagesetupdlg.rtMargin.Left
  RightMargin = pPagesetupdlg.rtMargin.Right
  TopMargin = pPagesetupdlg.rtMargin.Top
  BottomMargin = pPagesetupdlg.rtMargin.Bottom
Else
  MyPageSetupDlg = False
  FreeMemory pPagesetupdlg.hDevMode, pPagesetupdlg.hDevNames
  pPagesetupdlg.hDevMode = 0
  pPagesetupdlg.hDevNames = 0
  pointToDevMode = 0
  pointToDevNames = 0
'  ResErr = CommDlgExtendedError
'  Debug.Print ResErr
End If
End Function

Public Function MyPrintDlg(PrnArg As Printer, hDCArg As Long, _
                           PrintToFile As Boolean, _
                           PrintRange As Long, _
                           FromPage As Long, _
                           ToPage As Long, _
                           Copies As Integer, _
                           Collate As Boolean, _
                           Optional hwndOwnerArg As Long = 0 _
                                                  ) As Boolean
Static pPrintDlg As PRINTDLG
Dim Flg1 As Long

pPrintDlg.lStructSize = Len(pPrintDlg)
pPrintDlg.hwndOwner = hwndOwnerArg
If pointToDevMode <> 0 Then
  pPrintDlg.hDevMode = pointToDevMode
  pPrintDlg.hDevNames = pointToDevNames
End If
pPrintDlg.hInstance = App.hInstance

If PrintRange = PD_PAGENUMS Then
  Flg1 = PD_PAGENUMS
ElseIf PrintRange = PD_SELECTION Then
  Flg1 = PD_SELECTION
Else
  Flg1 = 0
End If

pPrintDlg.flags = PD_RETURNDC Or Flg1

pPrintDlg.nMinPage = 0
pPrintDlg.nMaxPage = 32767
pPrintDlg.nFromPage = FromPage
pPrintDlg.nToPage = ToPage

If PRINTDLG(pPrintDlg) = API_TRUE Then
  MyPrintDlg = True
  MyCopyStructure pDevMode, pPrintDlg.hDevMode
  hDCArg = pPrintDlg.hDC
  Copies = pDevMode.dmCopies
  PrnArg.Copies = Copies
  PrnArg.Orientation = pDevMode.dmOrientation
  PrnArg.PaperSize = pDevMode.dmPaperSize
  PrnArg.PrintQuality = pDevMode.dmPrintQuality
  PrintToFile = (pPrintDlg.flags And PD_PRINTTOFILE)
  FromPage = pPrintDlg.nFromPage
  ToPage = pPrintDlg.nToPage
  
  If (pPrintDlg.flags And PD_PAGENUMS) Then
    PrintRange = PD_PAGENUMS
  ElseIf (pPrintDlg.flags And PD_SELECTION) Then
    PrintRange = PD_SELECTION
  Else
    PrintRange = 0
  End If
  
  If pDevMode.dmCollate = DM_COLLATE Then
    Collate = True
  Else
    Collate = False
  End If
  
  pointToDevMode = pPrintDlg.hDevMode
  pointToDevNames = pPrintDlg.hDevNames
Else
  MyPrintDlg = False
  FreeMemory pPrintDlg.hDevMode, pPrintDlg.hDevNames
  pPrintDlg.hDevMode = 0
  pPrintDlg.hDevNames = 0
  pointToDevMode = 0
  pointToDevNames = 0
'  ResErr = CommDlgExtendedError
'  Debug.Print ResErr
End If
End Function

Public Function MyGetDirStr(Str1 As String) As String
Dim i As Integer, i1 As Integer, k As Integer
Dim St1 As String

If Len(Str1) > 0 Then
  k = 1
  Do
    i = InStr(k, Str1, "\")
    If i <> 0 Then i1 = i: k = i + 1
  Loop While i <> 0
  If i1 <> 0 Then
    St1 = Left$(Str1, i1)
  Else
    i = InStr(1, Str1, ":")
    If i = 0 Then
      St1 = ""
    Else
      St1 = Left$(Str1, i1) & "\"
    End If
  End If
Else
  St1 = ""
End If

MyGetDirStr = St1
End Function

Public Function NormalizeDir(Str1 As String) As String
If Len(Str1) = 0 Then
  NormalizeDir = ""
  Exit Function
Else
  If Right$(Str1, 1) <> "\" Then
    NormalizeDir = Str1 & "\"
    Exit Function
  Else
    NormalizeDir = Str1
    Exit Function
  End If
End If
End Function


Public Function RunAndWait(CmdLine As String, ShowFlag As VbAppWinStyle) As RunResultEnum
Dim IDProc As Long
Dim hProc As Long
Dim x1 As Long
Dim x2 As Long
RunAndWait = RRENotExecute
On Error GoTo Err_RunAndWait
IDProc = Shell(CmdLine, ShowFlag)
If IDProc <> 0 Then
  RunAndWait = RRECantSynchronize = 2
  hProc = OpenProcess(PROCESS_QUERY_INFORMATION, False, IDProc)
  If hProc <> 0 Then
    Do
      x1 = GetExitCodeProcess(hProc, x2)
      DoEvents
      DoEvents
      Sleep 0
    Loop While x1 = API_TRUE And x2 = STILL_ACTIVE
    RunAndWait = RRERunAndWaitSuccess
    x1 = CloseHandle(hProc)
  End If
End If
Exit_RunAndWait:
Exit Function
Err_RunAndWait:
Select Case Err.Number
Case 53
  MsgBox "  !", 48, ""
End Select
Resume Exit_RunAndWait
End Function

Public Function RunAndWait2(CmdLine As String, ShowFlag As VbAppWinStyle, Optional RunMode As RunModeEnum = 0, Optional ParLine As String = "", Optional DefDir As String = "") As RunResultEnum
Dim x1 As Long
Dim x2 As Long
Dim shi As SHELLEXECUTEINFO
RunAndWait2 = RRENotExecute
shi.cbSize = Len(shi)
shi.fMask = SEE_MASK_NOCLOSEPROCESS
shi.lpFile = VB2LP(CmdLine)
If UCase$(Right$(CmdLine, 3)) = "EXE" Then
  shi.nShow = ShowFlag
Else
  shi.nShow = 0
  Select Case RunMode
  Case 0 '  
  Case 1 ' 
    shi.lpVerb = VB2LP("Open")
  Case 2 ' 
    shi.lpVerb = VB2LP("Print")
  End Select
End If
If Len(ParLine) > 1 Then
  shi.lpParameters = VB2LP(ParLine)
End If
If Len(DefDir) > 1 Then
  shi.lpDirectory = VB2LP(DefDir)
End If
If ShellExecuteEx(shi) = API_TRUE Then
  RunAndWait2 = RRECantSynchronize = 2
  If shi.hProcess <> 0 Then
    Do
      x1 = GetExitCodeProcess(shi.hProcess, x2)
      DoEvents
      DoEvents
      Sleep 0
    Loop While x1 = API_TRUE And x2 = STILL_ACTIVE
    RunAndWait2 = RRERunAndWaitSuccess
    x1 = CloseHandle(shi.hProcess)
  End If
Else
  x1 = Err.LastDllError
  MsgBox "   " & CmdLine, 48, ""
End If
End Function

Private Function VB2LP(St1 As String) As String
VB2LP = Left$(St1, 254) & vbNullChar
End Function

Private Function LP2VB(St1) As String
LP2VB = Left$(St1, InStr(1, St1, vbNullChar) - 1)
End Function

Private Function LP2VB2(St1) As String
LP2VB2 = Left$(St1, InStr(1, St1, vbNullChar & vbNullChar) - 1)
End Function

Private Function LPBuff(n As Integer) As String
LPBuff = String(n, vbNullChar)
End Function

Private Sub VB2BYTE(St1 As String, Mass1() As Byte)
Dim i As Integer
Dim j As Long
j = UBound(Mass1) - 1
If j > Len(St1) - 1 Then j = Len(St1) - 1
For i = 0 To j Mod 32768
  Mass1(i) = Asc(Mid(St1, i + 1, 1))
Next
Mass1(i) = 0
End Sub

Private Function BYTE2VB(Mass1() As Byte) As String
Dim St1 As String
Dim i As Integer
St1 = ""
For i = 0 To UBound(Mass1) Mod 32768
  If Mass1(i) = 0 Then Exit For
  St1 = St1 & Chr(Mass1(i))
Next
BYTE2VB = St1
End Function

Private Sub MemoryError()
MsgBox "  ,   !", 16, " "
End Sub

Private Sub FreeMemory(handle1 As Long, handle2 As Long)
Dim X As Long
If handle1 <> 0 Then
  X = GlobalFree(handle1)
  If X <> 0 Then MemoryError
End If
If handle2 <> 0 Then
  X = GlobalFree(handle2)
  If X <> 0 Then MemoryError
End If
End Sub

Private Sub MyCopyStructure(PointTo As DEVMODE, HandleFrom As Long)
Dim X As Long
X = GlobalLock(HandleFrom)
CopyMemory PointTo, ByVal X, Len(PointTo)
X = GlobalUnlock(HandleFrom)
If X = 0 Then
  If Err.LastDllError <> 0 Then
    MemoryError
  End If
End If
End Sub

Private Function MyGetLpStr(St1 As String) As String
Dim i As Variant
i = InStr(1, St1, vbNullChar)
If IsNull(i) Then
  MyGetLpStr = ""
  St1 = ""
  Exit Function
ElseIf i = 0 Then
  MyGetLpStr = St1
  St1 = ""
  Exit Function
Else
  MyGetLpStr = Left$(St1, i - 1)
  St1 = Right$(St1, Len(St1) - i)
  Exit Function
End If
End Function

